--[[
	TitanJustice: A simple Display of current Justice value as a percent
	Author: Subwired
--]]

local menutext = "Titan|cffff8800 Justice Points|r"
local buttonlabel = "Justice: "
local ID = "JP"
local elap, JP, prevJP = 0, 0.0, -2
local GetUnitJP = 0 
local startVal = 0
local inInstance, instanceType, instanceStarted


-- Main button frame and addon base
local f = CreateFrame("Button", "TitanPanelJPButton", CreateFrame("Frame", nil, UIParent), "TitanPanelComboTemplate")
f:SetFrameStrata("FULLSCREEN")
f:SetScript("OnEvent", function(this, event, ...) this[event](this, ...) end)
f:RegisterEvent("ADDON_LOADED")


function f:ADDON_LOADED(a1)
--print ("a1 = " .. a1)
	if a1 ~= "TitanJusticePoints" then -- needs to be the name of the folder that the addon is in
	return 
	end
	self:UnregisterEvent("ADDON_LOADED")
	self.ADDON_LOADED = nil

	local name, isHeader, isExpanded, isUnused, isWatched, count, icon, maximum, hasWeeklyLimit, currentWeeklyAmount, unknown
	local i = 0
	local CurrencyIndex = 0


 


	self.registry = {
		id = ID,
		menuText = menutext,
		buttonTextFunction = "TitanPanelJPButton_GetButtonText",
		tooltipTitle = ID,
		tooltipTextFunction = "TitanPanelJPButton_GetTooltipText",
		frequency = 2,
		icon = "Interface\\Icons\\Pvecurrency-justice.blp",
		iconWidth = 16,
		category = "Information",
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = false,
			
		},
	}
	self:SetScript("OnUpdate", function(this, a1)
		elap = elap + a1
		if elap < 1 then return end
		
		
		
		-- "none" when outside an instance
        -- "pvp" when in a battleground
        -- "arena" when in an arena
        -- "party" when in a 5-man instance
        -- "raid" when in a raid instance 
		


			for i = 1, GetCurrencyListSize(), 1 do
				name, isHeader, isExpanded, isUnused, isWatched, count, icon, maximum, hasWeeklyLimit, currentWeeklyAmount, unknown = GetCurrencyListInfo(i)
				--if name == "Justice Points" then
				--print (icon)
				if icon == "Interface\\Icons\\pvecurrency-justice" then
					CurrencyIndex = i
				end
			--print(name)
			--Honor Points
			--Conquest Points
			--Valor Points
			--Justice Points
		end
		
		name, isHeader, isExpanded, isUnused, isWatched, count, icon, maximum, hasWeeklyLimit, currentWeeklyAmount, unknown = GetCurrencyListInfo(CurrencyIndex)
 
		local inInstance, instanceType = IsInInstance()
		--if inInstance and instanceType == "pvp"  then
		if GetNumPartyMembers() > 0 then
			if instanceStarted == 0 then
				startVal = count	
								
			end
			instanceStarted = 1
		else
			instanceStarted = 0
		end

		 JP = count
		
		
		if JP == prevJP then return end
		prevJP  = JP
		TitanPanelButton_UpdateButton(ID)
		elap = 0
	end)
		
	--TitanPanelButton_OnLoad(self)
end



function TitanPanelJPButton_GetButtonText()
----------------------------------------------
	local JPtext, pitchtext
	if not JP then
		JPtext = "0"
	else	
		if startVal == count or startVal == 0 then
			JPtext = string.format("%.0f", JP) .."" 
		else
			if JP - startVal == 0 then
				JPtext = string.format("%.0f", JP) .."" 
			else
				JPtext = string.format("%.0f", JP) .." (+".. JP - startVal..")"
		end
 
	end
end
	return buttonlabel, JPtext
end

-----------------------------------------------
function TitanPanelJPButton_GetTooltipText()
-----------------------------------------------

	return "Displays your current Justice Points "
end

local temp = {}
local function UIDDM_Add(text, func, checked, keepShown)
	temp.text, temp.func, temp.checked, temp.keepShownOnClick = text, func, checked, keepShown
	UIDropDownMenu_AddButton(temp)
end

function TitanPanelRightClickMenu_PrepareJPMenu()
----------------------------------------------------
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[ID].menuText)
	
	TitanPanelRightClickMenu_AddToggleIcon(ID)
	TitanPanelRightClickMenu_AddToggleLabelText(ID)
	TitanPanelRightClickMenu_AddSpacer()
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, ID, TITAN_PANEL_MENU_FUNC_HIDE)
end